unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, 
  Dialogs, StdCtrls, LMessages, LCLIntf;

type

  { TMyEdit }

  TMyEdit = class(TCustomEdit)
  private
    FExtCursorReadOnly: TCursor;
  protected
    procedure SetExtCursorReadOnly(AValue: TCursor);
    procedure LMSetCursor(var AMessage: TLMSetCursor); message LM_SETCURSOR;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property ExtCursorReadOnly: TCursor read FExtCursorReadOnly write SetExtCursorReadOnly default crDefault;
  end;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    MyEdit: TMyEdit;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyEdit := TMyEdit.Create(Self);
  MyEdit.Left := 10;
  MyEdit.Top  := 10;
  MyEdit.Parent := Form1;
  MyEdit.ExtCursorReadOnly := crNone;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  MyEdit.ReadOnly := not MyEdit.ReadOnly;
end;

{ TMyEdit }

procedure TMyEdit.SetExtCursorReadOnly(AValue: TCursor);
begin
  if FExtCursorReadOnly = AValue then Exit;
  FExtCursorReadOnly := AValue;
end;

procedure TMyEdit.LMSetCursor(var AMessage: TLMSetCursor);
var
  lDoInherited: Boolean;
begin
  lDoInherited := true;
  if (not (csDesigning in ComponentState)) then begin
    if ((ReadOnly) and (FExtCursorReadOnly <> crDefault)) then
    begin
      LCLIntf.SetCursor(Screen.Cursors[FExtCursorReadOnly]);
      AMessage.Result := 1;
      lDoInherited := false;
    end;
  end;

  if (lDoInherited) then
  begin
    inherited;
  end;
end;

constructor TMyEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

end.

